#include <bits/stdc++.h>

using namespace std;

int main()
{
    int n;
    cin >> n;
    int a[n];
    for(int i = 0; i < n; ++i) cin >> a[i];
    int k;
    cin >> k;
    for(int br = 0; br < k; ++br)
    {
        int l, r;
        cin >> l >> r;
        --l; --r;
        bool izbrisano = false;
        bool netacan = false;
        bool prvi = false;
        for(int i = l; i < r; ++i)
        {
            if(i + 1 <= r && a[i] > a[i + 1])
            {
                if(prvi)
                {
                    cout << "NE" << endl;
                    netacan = true;
                    break;
                }
                a[i] = -1;
                izbrisano = true;
                prvi = true;
            }
            if(izbrisano)
            {
                izbrisano = false;
                int j = i;
                while(j >= l && a[j] == -1) --j;
                if(j == l - 1) ++j;
                if(i + 1 <= r && a[i + 1] < a[j])
                {
                    cout << "NE" << endl;
                    netacan = true;
                    break;
                }
            }
        }
        if(!netacan) cout << "DA" << endl;
    }
    return 0;
}
/*
10
2 3 1 2 4 5 1 7 8 1
1
*/